/*_________________________________________________________________________
                              U S I N G   S W I T C H    S T A T E M E N T S

                                       Created 1/23/2014 for C++ 2012
                                                     Ron Kessler
___________________________________________________________________________


Updated 1/24/2014

1/24/2014   Added a combo box to display the states instead of using a textbox

This program demonstrates how to use the switch structure. They choose a State & we
compute the sales tax rate.

C++ will not let you use strings in switch. It will let you evaluate a char, int and other value types. But since I want to
evaluate states (CA, AZ, etc.) I put them into a combo box and switch on the selected index. Remember, combo/list boxes
start indexing from zero.

Also shows how to use the Accept and Cancel buttons

*/

#pragma once

namespace My3UsingSwitch {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Summary for Form1
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	internal: System::Windows::Forms::Button^  btnQuit;
	protected: 
	internal: System::Windows::Forms::Button^  btnOK;
	internal: System::Windows::Forms::Label^  Label5;


	internal: System::Windows::Forms::Label^  Label3;
	internal: System::Windows::Forms::TextBox^  txtCity;
	internal: System::Windows::Forms::Label^  Label2;
	internal: System::Windows::Forms::TextBox^  txtName;
	internal: System::Windows::Forms::Label^  Label1;
	private: System::Windows::Forms::ComboBox^  cboStates;
	internal: 

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->btnQuit = (gcnew System::Windows::Forms::Button());
			this->btnOK = (gcnew System::Windows::Forms::Button());
			this->Label5 = (gcnew System::Windows::Forms::Label());
			this->Label3 = (gcnew System::Windows::Forms::Label());
			this->txtCity = (gcnew System::Windows::Forms::TextBox());
			this->Label2 = (gcnew System::Windows::Forms::Label());
			this->txtName = (gcnew System::Windows::Forms::TextBox());
			this->Label1 = (gcnew System::Windows::Forms::Label());
			this->cboStates = (gcnew System::Windows::Forms::ComboBox());
			this->SuspendLayout();
			// 
			// btnQuit
			// 
			this->btnQuit->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->btnQuit->Location = System::Drawing::Point(376, 82);
			this->btnQuit->Name = L"btnQuit";
			this->btnQuit->Size = System::Drawing::Size(75, 23);
			this->btnQuit->TabIndex = 22;
			this->btnQuit->Text = L"Quit";
			this->btnQuit->UseVisualStyleBackColor = true;
			this->btnQuit->Click += gcnew System::EventHandler(this, &Form1::btnQuit_Click);
			// 
			// btnOK
			// 
			this->btnOK->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->btnOK->Location = System::Drawing::Point(376, 37);
			this->btnOK->Name = L"btnOK";
			this->btnOK->Size = System::Drawing::Size(75, 23);
			this->btnOK->TabIndex = 21;
			this->btnOK->Text = L"OK";
			this->btnOK->UseVisualStyleBackColor = true;
			this->btnOK->Click += gcnew System::EventHandler(this, &Form1::btnOK_Click);
			// 
			// Label5
			// 
			this->Label5->ForeColor = System::Drawing::Color::Blue;
			this->Label5->Location = System::Drawing::Point(144, 176);
			this->Label5->Name = L"Label5";
			this->Label5->Size = System::Drawing::Size(261, 47);
			this->Label5->TabIndex = 27;
			this->Label5->Text = L"Notice the OK button is the default. I set the AcceptButton & Cancel Button prope" 
				L"rties on the form to these buttons.";
			// 
			// Label3
			// 
			this->Label3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->Label3->Location = System::Drawing::Point(68, 128);
			this->Label3->Name = L"Label3";
			this->Label3->Size = System::Drawing::Size(100, 23);
			this->Label3->TabIndex = 25;
			this->Label3->Text = L"State";
			// 
			// txtCity
			// 
			this->txtCity->Location = System::Drawing::Point(174, 85);
			this->txtCity->Name = L"txtCity";
			this->txtCity->Size = System::Drawing::Size(159, 20);
			this->txtCity->TabIndex = 19;
			// 
			// Label2
			// 
			this->Label2->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->Label2->Location = System::Drawing::Point(68, 86);
			this->Label2->Name = L"Label2";
			this->Label2->Size = System::Drawing::Size(100, 23);
			this->Label2->TabIndex = 24;
			this->Label2->Text = L"City";
			// 
			// txtName
			// 
			this->txtName->Location = System::Drawing::Point(174, 40);
			this->txtName->Name = L"txtName";
			this->txtName->Size = System::Drawing::Size(159, 20);
			this->txtName->TabIndex = 18;
			// 
			// Label1
			// 
			this->Label1->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 10, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->Label1->Location = System::Drawing::Point(68, 41);
			this->Label1->Name = L"Label1";
			this->Label1->Size = System::Drawing::Size(100, 23);
			this->Label1->TabIndex = 23;
			this->Label1->Text = L"Name";
			// 
			// cboStates
			// 
			this->cboStates->FormattingEnabled = true;
			this->cboStates->Location = System::Drawing::Point(174, 127);
			this->cboStates->Name = L"cboStates";
			this->cboStates->Size = System::Drawing::Size(79, 21);
			this->cboStates->TabIndex = 28;
			this->cboStates->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::cboStates_SelectedIndexChanged);
			// 
			// Form1
			// 
			this->AcceptButton = this->btnOK;
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->CancelButton = this->btnQuit;
			this->ClientSize = System::Drawing::Size(518, 261);
			this->Controls->Add(this->cboStates);
			this->Controls->Add(this->btnQuit);
			this->Controls->Add(this->btnOK);
			this->Controls->Add(this->Label5);
			this->Controls->Add(this->Label3);
			this->Controls->Add(this->txtCity);
			this->Controls->Add(this->Label2);
			this->Controls->Add(this->txtName);
			this->Controls->Add(this->Label1);
			this->Name = L"Form1";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"Using Switch Statements";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

        //***********START OF MY CODE************

       
		  static double salesTaxRate = 0;       //class level variable


		private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) 
				 
			{
                //---fill the combo box
                cboStates->Items->Add("CA");
                cboStates->Items->Add("AZ");
                cboStates->Items->Add("NV");
                cboStates->Items->Add("OR");
                cboStates->Items->Add("WA");

                cboStates->SelectedIndex =0;        // make sure the first one is selected
		    }




	    private: System::Void btnOK_Click(System::Object^  sender, System::EventArgs^  e) 
			 {
			        //---now decide the sales tax rate based upon the state they chose
					
                    MessageBox::Show("The sales tax for " + cboStates->SelectedItem->ToString() + " is " +  salesTaxRate + ".", "Using Switch" ,
						MessageBoxButtons::OK, MessageBoxIcon::Information);
			 
			 }

        private: System::Void cboStates_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) 
		 
		 {
		 
		          /*  ---now decide the sales tax rate based upon the state they chose. C++ will not let you evaluate a string using switch like you can in VB & C#.
                    That is why it is easier to use a combo box and switch on the index number.
                  */
                    
                    switch (cboStates->SelectedIndex)
                    {
                        case 0:                             //CA
                            salesTaxRate = .08;
                            break;
                
                        case 1:                             //AZ
                            salesTaxRate = .05;
                            break;
                        case 2:                             //NV
                            salesTaxRate = .01;
                            break;

                        case 3:                             //OR and WA are the same. If they choose OR, the switch "falls through" to case 4. Both OR and WA will have the same sales tax
						case 4:                             //WA
                            salesTaxRate = .06;
                            break;

                        
                  
                    }
		 
		 }
        private: System::Void btnQuit_Click(System::Object^  sender, System::EventArgs^  e) 
		 
		 {
             this->Close();
		 }
};
}

